hdu 5115 Dire Wolf 区间DP

Dire Wolf

Time Limit: 5000/5000 MS (Java/Others) Memory Limit: 512000/512000 K (Java/Others)
Total Submission(s): 439 Accepted Submission(s): 254

Problem Description

Dire wolves, also known as Dark wolves, are extraordinarily large and powerful wolves. Many, if not all, Dire Wolves appear to originate from Draenor.
Dire wolves look like normal wolves, but these creatures are of nearly twice the size. These powerful beasts, 8 – 9 feet long and weighing 600 – 800 pounds, are the most well-known orc mounts. As tall as a man, these great wolves have long tusked jaws that look like they could snap an iron bar. They have burning red eyes. Dire wolves are mottled gray or black in color. Dire wolves thrive in the northern regions of Kalimdor and in Mulgore.
Dire wolves are efficient pack hunters that kill anything they catch. They prefer to attack in packs, surrounding and flanking a foe when they can.
— Wowpedia, Your wiki guide to the World of Warcra

Matt, an adventurer from the Eastern Kingdoms, meets a pack of dire wolves. There are N wolves standing in a row (numbered with 1 to N from left to right). Matt has to defeat all of them to survive.

Once Matt defeats a dire wolf, he will take some damage which is equal to the wolf’s current attack. As gregarious beasts, each dire wolf i can increase its adjacent wolves’ attack by bi. Thus, each dire wolf i’s current attack consists of two parts, its basic attack ai and the extra attack provided by the current adjacent wolves. The increase of attack is temporary. Once a wolf is defeated, its adjacent wolves will no longer get extra attack from it. However, these two wolves (if exist) will become adjacent to each other now.

For example, suppose there are 3 dire wolves standing in a row, whose basic attacks ai are (3, 5, 7), respectively. The extra attacks bi they can provide are (8, 2, 0). Thus, the current attacks of them are (5, 13, 9). If Matt defeats the second wolf first, he will get 13 points of damage and the alive wolves’ current attacks become (3, 15).

As an alert and resourceful adventurer, Matt can decide the order of the dire wolves he defeats. Therefore, he wants to know the least damage he has to take to defeat all the wolves.

Input

The first line contains only one integer T , which indicates the number of test cases. For each test case, the first line contains only one integer N (2 ≤ N ≤ 200).

The second line contains N integers ai (0 ≤ ai ≤ 100000), denoting the basic attack of each dire wolf.

The third line contains N integers bi (0 ≤ bi ≤ 50000), denoting the extra attack each dire wolf can provide.

Output

For each test case, output a single line “Case #x: y”, where x is the case number (starting from 1), y is the least damage Matt needs to take.

Sample Input

2 3 3 5 7 8 2 0 10 1 3 5 7 9 2 4 6 8 10 9 4 1 2 1 2 1 4 5 1

Sample Output

Case #1: 17 Case #2: 74

Hint

In the first sample, Matt defeats the dire wolves from left to right. He takes 5 + 5 + 7 = 17 points of damage which is the least damage he has to take.

题意

有一排狼,攻击每一只狼会受到这只狼的伤害a[i],和周围狼的伤害b[i-1]+b[i+1],然后问你消灭这一排狼,最少受到多少伤害

分析

这是一个很明显的区间DP,类似于石子合并,能量项链的那种题
dp[i][j]=min(dp[i][k-1]+dp[k+1][j]+a[k]+b[i-1]+b[j+1],dp[i][j])
转移方程还是比较明显的
由于数据范围不大,直接跑一发就是了

代码

#define REP_1(i, n) for (int i=1;i<=n;++i)
#define RD(n) scanf("%d",&n)
#define FOR_1(i, a, b) for (int i=a;i<=b;++i)
#define maxn 210
int dp[maxn][maxn];
int a[maxn];
int b[maxn];
int main()
{
    int t;
    RD(t);
    REP_1(ti,t)
    {
        memset(dp,0,sizeof(dp));
        int n;
        RD(n);
        REP_1(i,n)
            RD(a[i]);
        REP_1(i,n)
            RD(b[i]);
        REP_1(i,n)
            FOR_1(j,i,n)
            {
                if(j==i)
                    dp[i][j]=a[i]+b[i-1]+b[j+1];
                dp[i][j]=inf/3;
            }
        REP(l,n+1)
        {
            REP_1(i,n)
            {
                int j=i+l;
                if(j>n)
                    break;
                FOR_1(k,i,j)
                    dp[i][j]=min(dp[i][k-1]+dp[k+1][j]+a[k]+b[i-1]+b[j+1],dp[i][j]);
            }
        }
        printf("Case #%d: %d\n",ti,dp[1][n]);
    }
}
    原文作者:qscqesze
    原文地址: https://www.cnblogs.com/qscqesze/p/4325043.html
    本文转自网络文章,转载此文章仅为分享知识,如有侵权,请联系博主进行删除。
点赞